#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

//Web: http://www.verypdf.com
//Web: http://www.verydoc.com
//Support Email: support@verypdf.com or support@verydoc.com

/////////////////////////////////////
//Function:
//  void VeryPDF2XMLSetLicenseCode(const char *lpCode);
//
//Description:
//  Register PDF2XML SDK Library.
//
//Parameters:
//  "lpCode" parameter is the license key which issued to you by VeryDOC company.
/////////////////////////////////////
__declspec(dllexport)
void VeryPDF2XMLSetLicenseCode(const char *lpCode);


/////////////////////////////////////
//Function:
//  BOOL WINAPI VeryPDF2XMLConverter(LPCTSTR lpInPDF, LPCTSTR lpOutXML, LPCTSTR lpOptions);
//  
//Description:
//  VeryPDF2XMLConverter() function can convert from PDF files to XML files.
//
//Parameters:
//  "lpOptions" parameter can be used to set additional options to PDF to XML Converter, you can set following options,
//  -password: set password for decryption, e.g., -password "123456"
//  -res     : set resolution in dpi, e.g., -res 300
//  -bitcount: set bitcount to output image file
//  -outimg  : generate output image file, e.g., -outimg "C:\\out.png", "-outimg" does support following image formats,
//             BMP, JPG, JPEG, GIF, PNG, MNG, JNG, ICO, TIF, TIFF, TGA, PCX, J2K, JP2, JPC, J2C, PNM, PGM, PPM, PBM
//  -txt     : output to utf-8 text file, e.g., -txt
//  -xml     : output to xml file, this is default format, e.g., -xml, 
//  -page    : page range, e.g., -page "1-3,5,9-"
//  
//Return value:
//  1 is successful and 0 is indicate something is wrong during conversion.
/////////////////////////////////////
__declspec(dllexport)
BOOL WINAPI VeryPDF2XMLConverter(LPCTSTR lpInPDF, LPCTSTR lpOutXML, LPCTSTR lpOptions);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
void main(int argc, char **argv)
{
	if(argc != 2)
	{
		printf("%s C:\\in.pdf\n", argv[0]);
		return;
	}
	char *lpInPDFFile = argv[1];
	char *lpLicenseKey = "XXXXXXXXXXXXXXXXXXXXXXX";
	VeryPDF2XMLSetLicenseCode(lpLicenseKey);

	char szOutInfoFile[MAX_PATH];
	GetModulePath(szOutInfoFile, "outimage-info.txt");
	BOOL bRet = FALSE;
	char szImgFile[MAX_PATH];
	GetModulePath(szImgFile, "outimage-%04d.png");
	char szOptions[1024];
	sprintf(szOptions, "-res 150 -bitcount 24 -outimg \"%s\"", szImgFile);
	bRet = VeryPDF2XMLConverter(lpInPDFFile, szOutInfoFile, szOptions);

	char szTxtFile[MAX_PATH];
	GetModulePath(szTxtFile, "out.txt");
	bRet = VeryPDF2XMLConverter(lpInPDFFile, szTxtFile, "-txt");

	char szOutXMLFile[MAX_PATH];
	GetModulePath(szOutXMLFile, "out.xml");
	bRet = VeryPDF2XMLConverter(lpInPDFFile, szOutXMLFile, "");
	printf("VeryPDF2XMLConverter, Return value: %d\n", bRet);
}